// WordCount.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "WordCount.h"
#include <Commdlg.h>
#include <commctrl.h>
#include <process.h>

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// ǉ̃O[oϐ
static HWND g_hwndEdit = 0;		// GfBbgE{bNX̃EBhEEnh
static HANDLE g_wcThread = NULL;// XbhEnh

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WORDCOUNT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_WORDCOUNT));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WORDCOUNT));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_WORDCOUNT);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//w肵CGfBbgE{bNX̖ɒǉ
void AppendText( LPCTSTR str)
{
	SendMessage( g_hwndEdit, EM_SETSEL, -1, -1);	//I
	SendMessage( g_hwndEdit, EM_REPLACESEL, FALSE, (LPARAM)str);
					//IȂ̎̌ĂяoƁCɒǉƂȂ
	SetFocus( g_hwndEdit);	//L[{[hEtH[JXZbg
}


// WordCountThread̃p[^\
struct WCParam
{
	TCHAR fname[MAX_PATH];	// Ώۂ̃t@C
};

// p[^Ŏw肳ꂽt@Cǂ݁C/ꐔ/sꂼꐔB
// ʂ̓CEEBhEɕ\B
unsigned _stdcall WordCountThread(void *param)
{
	unsigned rc = 0;
	WCParam *wcParam = (WCParam *)param;
	if(wcParam != NULL){
		// JnԂL^
		DWORD startTick = GetTickCount();
		
		AppendText(_T("s: ") );
		AppendText(wcParam->fname);
		AppendText(_T("\r\n") );
		
		HANDLE file = CreateFile(wcParam->fname, GENERIC_READ, FILE_SHARE_READ,
								 NULL, OPEN_EXISTING, 0, NULL);
		if(file != NULL){
			int charCount = 0;		// 
			int wordCount = 0;		// ꐔ
			int lineCount = 0;		// s
			bool prevCR = false;	// O̕CR?
			char buffer[1024];
			DWORD rd;
			while(ReadFile(file, buffer, sizeof(buffer), &rd, NULL) && rd > 0){
				char *ptr = buffer;
				for( DWORD i=0; i<rd; ptr++,i++){
					charCount++;
					switch(*ptr){
					case '\n':	// s͌ƍs̋؂
						// O̕CRȂCCR+LF1Ƃ邽߁C1炷
						if( prevCR)	charCount--;
						lineCount++;
						wordCount++;
						break;
					case ' ':	// Xy[Xƃ^u͌̋؂
					case '\t':
						wordCount++;
						break;
					}
					prevCR = *ptr == '\r';
				}
			}
			CloseHandle( file);
			
			// ʂo
			TCHAR msgbuf[256];
			DWORD ticks = GetTickCount() - startTick;
			wsprintf(msgbuf, _T("I܂B=%lu~b\r\n"), ticks);
			AppendText(msgbuf);
			wsprintf(msgbuf, _T("  : %d\r\n"), charCount);
			AppendText(msgbuf);
			wsprintf(msgbuf, _T("  ꐔ:   %d\r\n"), wordCount);
			AppendText(msgbuf);
			wsprintf(msgbuf, _T("  s:   %d\r\n\r\n"), lineCount);
			AppendText(msgbuf);
		}
		else{
			AppendText(_T("t@CI[vł܂ł\n\n"));
			rc = (unsigned)-1;
		}
		
		delete wcParam;	// p[^\̂Yꂸ폜
	}
	return rc;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_CREATE:
		{
			RECT rect;
			GetClientRect(hWnd, &rect);
			g_hwndEdit = CreateWindow(WC_EDIT,_T(""),
							WS_CHILDWINDOW|WS_VISIBLE|WS_VSCROLL
								|ES_MULTILINE|ES_AUTOVSCROLL,
							0, 0, rect.right, rect.bottom, hWnd,
							NULL, hInst, NULL);
			if(!g_hwndEdit)	return -1;
		}
		break;
	case WM_SIZE:
		{
			//CEEBhETCYύXꂽƂɁC
			//GfBbgE{bNXɍ킹B
			RECT rect;
			GetClientRect(hWnd, &rect);
			MoveWindow(g_hwndEdit, 0, 0, rect.right, rect.bottom, TRUE);
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case IDM_EXECWC:
			{
				// Xbh܂sǂ`FbNB2dN͂ȂB
				if(g_wcThread != NULL && WaitForSingleObject(g_wcThread, 0) == WAIT_TIMEOUT){
					MessageBox(hWnd, _T("ݎŝ߁Cʂ̏󂯕t܂B"),
								_T("WordCount"), MB_OK|MB_ICONEXCLAMATION);
					break;
				}
				CloseHandle(g_wcThread);
				
				TCHAR fname[MAX_PATH] = _T("");
				OPENFILENAME ofn;
				
				ZeroMemory(&ofn, sizeof(ofn) );	// \̂̑So[[ENA
				ofn.lStructSize = sizeof(ofn);	// \̂̎TCYݒiK{j
				ofn.hwndOwner = hWnd;			// t@CE_CAÕI[i[EEBhE
				ofn.lpstrFile = fname;			// 肵t@C邽߂̃obt@
				ofn.nMaxFile = MAX_PATH;		// obt@̃TCY
				if(GetOpenFileName(&ofn)){
					WCParam *threadParam = new WCParam;	// mۂ́CXbh̒ō폜
					_tcscpy(threadParam->fname, fname);
					g_wcThread = (HANDLE)_beginthreadex( NULL, 0, WordCountThread, threadParam, 0, NULL);
				}
			}
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		if(g_wcThread != NULL)	CloseHandle(g_wcThread);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
